--[[
	3sat-Mediathek(light)
	Vers.: 0.4 beta
	Copyright (C) 2016, bazi98
        with many hints and code snippets from SatBaby, big thanks from my to him

        App Description:
        There the player links are respectively read about the recent news reports of the German,Austria and Swiss Television "3sat"
        from the 3sat library, displays and allows them to play with the neutrino-movie player.

	License: GPL

	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public
	License as published by the Free Software Foundation; either
	version 2 of the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
	General Public License for more details.

	You should have received a copy of the GNU General Public
	License along with this program; if not, write to the
	Free Software Foundation, Inc., 51 Franklin St, Fifth Floor,
	Boston, MA  02110-1301, USA.

        Copyright (C) for the linked videos and for the 3sat-Logo by 3sat or the respective owners!
]]

qual = 1
-- 1 = HD-Qualität = 1280x720px ( DSL > 6000 )
-- 2 = MD-Qualität = 1024x576px ( DSL > 2000 )
-- 3 = SD-Qualität = 852x480px  ( DSL < 2000 )

-- webm-Streamadressen in mp4-Streamadresse wandeln
function conv_url(_string)
	if _string == nil then return _string end
		if qual < 2 then -- = qual = 1 = HD
			_string = string.gsub(_string,"776k_p17v13.webm","3328k_p36v13.mp4");
			_string = string.gsub(_string,"776k_p17v12.webm","3328k_p36v12.mp4"); 
			_string = string.gsub(_string,"776k_p17v11.webm","2256k_p14v11.mp4"); --- bei Sendungen mit 776k_p17v11.webm ist HD nicht verfügbar deshalb MD-Qualität
	
		elseif qual > 2 then -- = qual = 3 = SD
			_string = string.gsub(_string,"776k_p17v13.webm","1496k_p13v13.mp4");
			_string = string.gsub(_string,"776k_p17v12.webm","1496k_p13v12.mp4");
			_string = string.gsub(_string,"776k_p17v11.webm","1456k_p13v11.mp4");
		else  -- = qual = 2 = MD
			_string = string.gsub(_string,"776k_p17v13.webm","2328k_p35v13.mp4");
			_string = string.gsub(_string,"776k_p17v12.webm","2328k_p35v12.mp4");
			_string = string.gsub(_string,"776k_p17v11.webm","2256k_p14v11.mp4");
		end
			return _string
end

--Objekte
function script_path()
	local str = debug.getinfo(2, "S").source:sub(2)
	return str:match("(.*/)")
end

function init()
	n = neutrino();
	p = {}
	func = {}
	pmid = 0
	stream = 1
        tmpPath = "/tmp"
end

function add_stream(t,u,f)
  p[#p+1]={title=t,url=u,from=f,access=stream}
end

function getdata(Url,outputfile)
	if Url == nil then return nil end
	if Curl == nil then
		Curl = curl.new()
	end
	local ret, data = Curl:download{url=Url,A="Mozilla/5.0;",followRedir=true,o=outputfile }
	if ret == CURL.OK then
		return data
	else
		return nil
	end
end

-- UTF8 in Umlaute wandeln
function conv_str(_string)
	if _string == nil then return _string end
	_string = string.gsub(_string,"&amp;","&");
	_string = string.gsub(_string,"&#039;","'");
	_string = string.gsub(_string,"&#261;","ą");
	_string = string.gsub(_string,"&quot;","");
	_string = string.gsub(_string,"&apos;","'");
	_string = string.gsub(_string,"&auml;","ä");
	_string = string.gsub(_string,"&ouml;","ö");
	_string = string.gsub(_string,"&uuml;","ü");
	return _string
end

function fill_playlist() --- > begin playlist

--beginn 3sat.full: Mediathek-Beiträge
	local data = getdata('http://www.3sat.de/mediathek/rss/mediathek.xml',nil)
	if data then
		for  item in data:gmatch('<item>(.-)</item>')  do
			local title = item:match("<title>(.-)</title>") -- Sendungstitel
			local url = item:match('url="(.-webm)"') -- URL
			local date = item:match("<description>ganze(.-):") -- Sendungsdatum
			local full = item:match('<description>(ganze Sendung)',nil) -- es werden nur ganze Folgen angezeigt und keine 1 Minuten-Vorschauen ecta. deaktivieren wenn Vorschauen gewünscht sind
--			if url and title then -- aktivieren wenn Vorschauen angezeigt werden sollen
			if url and title and full then -- deaktivieren wenn Vorschauen gewünscht sind
				add_stream(conv_str(title), conv_url(url), date)
			end
            end
	end
end --- > end of playlist

function set_pmid(id)
  pmid=tonumber(id);
  return MENU_RETURN["EXIT_ALL"];
end

function select_playitem()
  local m=menu.new{name="3sat-Mediathek (light)", icon=""}
  for i,r in  ipairs(p) do
    m:addItem{type="forwarder", action="set_pmid", id=i, icon="streaming", name=r.title, hint=r.from, hint_icon="hint_reload"}
  end

  repeat
    pmid=0
    m:exec()
    if pmid==0 then
      return
    end

    local vPlay = nil
    local url=func[p[pmid].access](p[pmid].url)
    if url~=nil then
      if  vPlay  ==  nil  then
	vPlay  =  video.new()
      end
 	vPlay:PlayFile("3sat",url,p[pmid].title,url);
   end
  until false
end

--Main
init()
func={
  [stream]=function (x) return x end,
}
fill_playlist()
select_playitem()

